/*
 * DropShadowBorderPanel.java
 *
 * Created on April 28, 2005, 10:27 AM
 */

package org.jdesktop.demo.swingx_dev;
import java.awt.Insets;
import javax.swing.JComponent;
import javax.swing.border.EtchedBorder;
import org.jdesktop.demo.DemoPanel;
import org.jdesktop.demo.MainWindow;
import org.jdesktop.swingx.border.DropShadowBorder;

/**
 *
 * @author  patrick
 */
public class DevDropShadowBorderPanel extends DemoPanel {
    EtchedBorder eb = new EtchedBorder();
    DropShadowBorder dsb = new DropShadowBorder();
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        MainWindow.main(new String[]{"-d", DevDropShadowBorderPanel.class.getName()});
    }
   
    /** Creates new form DropShadowBorderPanel */
    public DevDropShadowBorderPanel() {
        setName("Drop Shadow Border Demo");
        initComponents();
        Insets i = jTextField1.getInsets();
        i.set(5,5,5,5);
    }

    public String getHtmlDescription() {
        return "<html>Demonstrates various uses of drop-shadow borders (DSB). In particular, it highlights problems with " +
                "components where attaching the DSB causes odd rendering behavior component sizing. You may want to " +
                "maximize the window containing this panel if components don't appear to render correctly. Note that" +
                "DSB is really only recommended for JPanels, as with other components the DSB may take too much of " +
                "the space that gives the component it's distinguishing appearance.</html>";
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        buttonGroup1 = new javax.swing.ButtonGroup();
        plainComponentsPanel = new javax.swing.JPanel();
        plainDesc = new javax.swing.JLabel();
        jLabel1 = new javax.swing.JLabel();
        jTextField2 = new javax.swing.JTextField();
        jButton2 = new javax.swing.JButton();
        jRadioButton2 = new javax.swing.JRadioButton();
        jCheckBox2 = new javax.swing.JCheckBox();
        jComboBox2 = new javax.swing.JComboBox();
        jTextArea2 = new javax.swing.JTextArea();
        jList2 = new javax.swing.JList();
        jComboBox3 = new javax.swing.JComboBox();
        compWithinPanelsPanel = new javax.swing.JPanel();
        embeddedDesc = new javax.swing.JLabel();
        lblEmbedPNL = new javax.swing.JPanel();
        jLabel7 = new javax.swing.JLabel();
        tfEmbedPNL = new javax.swing.JPanel();
        jTextField1 = new javax.swing.JTextField();
        btnEmbedPNL = new javax.swing.JPanel();
        jButton1 = new javax.swing.JButton();
        rbEmbedPNL = new javax.swing.JPanel();
        jRadioButton1 = new javax.swing.JRadioButton();
        cxEmbedPNL = new javax.swing.JPanel();
        jCheckBox1 = new javax.swing.JCheckBox();
        cbxEmbedPNL = new javax.swing.JPanel();
        jComboBox1 = new javax.swing.JComboBox();
        listEmbedPNL = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        jList1 = new javax.swing.JList();
        listEmbedPNL1 = new javax.swing.JPanel();
        jScrollPane3 = new javax.swing.JScrollPane();
        jList3 = new javax.swing.JList();
        taEmbedPNL = new javax.swing.JPanel();
        jScrollPane2 = new javax.swing.JScrollPane();
        jTextArea1 = new javax.swing.JTextArea();

        setLayout(new java.awt.GridBagLayout());

        plainComponentsPanel.setLayout(new java.awt.GridBagLayout());

        plainDesc.setText("Components which have DSB assigned directly");
        plainComponentsPanel.add(plainDesc, new java.awt.GridBagConstraints());

        jLabel1.setText("jLabel1");
        jLabel1.setBorder(new DropShadowBorder());
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 0, 6, 0);
        plainComponentsPanel.add(jLabel1, gridBagConstraints);

        jTextField2.setText("jTextField2");
        jTextField2.setBorder(new DropShadowBorder());
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 0, 5, 0);
        plainComponentsPanel.add(jTextField2, gridBagConstraints);

        jButton2.setText("jButton2");
        jButton2.setBorder(new DropShadowBorder());
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 0, 5, 0);
        plainComponentsPanel.add(jButton2, gridBagConstraints);

        jRadioButton2.setText("jRadioButton2");
        jRadioButton2.setBorder(new DropShadowBorder());
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 0, 5, 0);
        plainComponentsPanel.add(jRadioButton2, gridBagConstraints);

        jCheckBox2.setText("jCheckBox2");
        jCheckBox2.setBorder(new DropShadowBorder());
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 0, 5, 0);
        plainComponentsPanel.add(jCheckBox2, gridBagConstraints);

        jComboBox2.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Item1", "Item2", "Item3", "Item4" }));
        jComboBox2.setBorder(new DropShadowBorder());
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 0, 5, 0);
        plainComponentsPanel.add(jComboBox2, gridBagConstraints);

        jTextArea2.setColumns(20);
        jTextArea2.setLineWrap(true);
        jTextArea2.setText("This is a sample text area. This is a sample text area. This is a sample text area. This is a sample text area. This is a sample text area. This is a sample text area. ");
        jTextArea2.setBorder(new DropShadowBorder());
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 7;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 0, 5, 0);
        plainComponentsPanel.add(jTextArea2, gridBagConstraints);

        jList2.setBorder(new DropShadowBorder());
        jList2.setModel(new javax.swing.AbstractListModel() {
            String[] strings = { "Item1", "Item2", "Item3", "Item4" };
            public int getSize() { return strings.length; }
            public Object getElementAt(int i) { return strings[i]; }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 8;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 0, 5, 0);
        plainComponentsPanel.add(jList2, gridBagConstraints);

        jComboBox3.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Item1", "Item2", "Item3", "Item4" }));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 9;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(6, 1, 6, 1);
        plainComponentsPanel.add(jComboBox3, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTH;
        gridBagConstraints.insets = new java.awt.Insets(10, 10, 10, 10);
        add(plainComponentsPanel, gridBagConstraints);

        compWithinPanelsPanel.setLayout(new java.awt.GridBagLayout());

        embeddedDesc.setText("Components embedded within a Panel, which has DSB assigned");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridwidth = 2;
        compWithinPanelsPanel.add(embeddedDesc, gridBagConstraints);

        lblEmbedPNL.setBorder(new DropShadowBorder());
        jLabel7.setText("First Name:");
        lblEmbedPNL.add(jLabel7);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 0, 5, 0);
        compWithinPanelsPanel.add(lblEmbedPNL, gridBagConstraints);

        tfEmbedPNL.setBorder(new DropShadowBorder());
        jTextField1.setText("This is a single line text field for data entry.");
        jTextField1.setBorder(null);
        tfEmbedPNL.add(jTextField1);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 0, 5, 0);
        compWithinPanelsPanel.add(tfEmbedPNL, gridBagConstraints);

        btnEmbedPNL.setBorder(new DropShadowBorder());
        jButton1.setText("Submit");
        jButton1.setPreferredSize(new java.awt.Dimension(80, 25));
        btnEmbedPNL.add(jButton1);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 0, 5, 0);
        compWithinPanelsPanel.add(btnEmbedPNL, gridBagConstraints);

        rbEmbedPNL.setBorder(new DropShadowBorder());
        jRadioButton1.setText("Marketing Materials");
        rbEmbedPNL.add(jRadioButton1);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 0, 5, 0);
        compWithinPanelsPanel.add(rbEmbedPNL, gridBagConstraints);

        cxEmbedPNL.setBorder(new DropShadowBorder());
        jCheckBox1.setText("True");
        cxEmbedPNL.add(jCheckBox1);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 0, 5, 0);
        compWithinPanelsPanel.add(cxEmbedPNL, gridBagConstraints);

        cbxEmbedPNL.setBorder(new DropShadowBorder(java.awt.Color.BLACK, 0, 5));
        jComboBox1.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Item1", "Item2", "Item3", "Item4" }));
        cbxEmbedPNL.add(jComboBox1);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 0, 5, 0);
        compWithinPanelsPanel.add(cbxEmbedPNL, gridBagConstraints);

        listEmbedPNL.setBorder(new DropShadowBorder());
        jList1.setModel(new javax.swing.AbstractListModel() {
            String[] strings = { "Item1", "Item2", "Item3", "Item4" };
            public int getSize() { return strings.length; }
            public Object getElementAt(int i) { return strings[i]; }
        });
        jScrollPane1.setViewportView(jList1);

        listEmbedPNL.add(jScrollPane1);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 7;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 0, 5, 0);
        compWithinPanelsPanel.add(listEmbedPNL, gridBagConstraints);

        listEmbedPNL1.setBorder(new DropShadowBorder());
        jList3.setModel(new javax.swing.AbstractListModel() {
            String[] strings = { "Item1", "Item2", "Item3", "Item4", "Item1", "Item2", "Item3", "Item4", "Item1", "Item2", "Item3", "Item4", "Item1", "Item2", "Item3", "Item4", "Item1", "Item2", "Item3", "Item4", "Item1", "Item2", "Item3", "Item4" };
            public int getSize() { return strings.length; }
            public Object getElementAt(int i) { return strings[i]; }
        });
        jScrollPane3.setViewportView(jList3);

        listEmbedPNL1.add(jScrollPane3);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 7;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 0, 5, 0);
        compWithinPanelsPanel.add(listEmbedPNL1, gridBagConstraints);

        taEmbedPNL.setBorder(new DropShadowBorder());
        taEmbedPNL.setOpaque(false);
        jScrollPane2.setBorder(null);
        jTextArea1.setColumns(30);
        jTextArea1.setLineWrap(true);
        jTextArea1.setRows(4);
        jTextArea1.setText("A test area text area. To get this effect, the JTextArea was placed within a JPanel, and the DropShadowBorder was placed on the JPanel. If you tried to add a DropShadowBorder to the JTextArea itself, you would get a funny effect because the Look and Feel installs a different border on the JTextArea in addition to the border specified.");
        jTextArea1.setWrapStyleWord(true);
        jTextArea1.setBorder(null);
        jScrollPane2.setViewportView(jTextArea1);

        taEmbedPNL.add(jScrollPane2);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 8;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 0, 5, 0);
        compWithinPanelsPanel.add(taEmbedPNL, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 0.8;
        gridBagConstraints.insets = new java.awt.Insets(10, 10, 10, 10);
        add(compWithinPanelsPanel, gridBagConstraints);

    }
    // </editor-fold>//GEN-END:initComponents
    
    private void flipBorder(JComponent comp, boolean shadow) {
            comp.setBorder(shadow ? dsb : null);
    }

    public void addMenuItems(javax.swing.JMenuBar menuBar) {
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel btnEmbedPNL;
    private javax.swing.ButtonGroup buttonGroup1;
    private javax.swing.JPanel cbxEmbedPNL;
    private javax.swing.JPanel compWithinPanelsPanel;
    private javax.swing.JPanel cxEmbedPNL;
    private javax.swing.JLabel embeddedDesc;
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JCheckBox jCheckBox1;
    private javax.swing.JCheckBox jCheckBox2;
    private javax.swing.JComboBox jComboBox1;
    private javax.swing.JComboBox jComboBox2;
    private javax.swing.JComboBox jComboBox3;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JList jList1;
    private javax.swing.JList jList2;
    private javax.swing.JList jList3;
    private javax.swing.JRadioButton jRadioButton1;
    private javax.swing.JRadioButton jRadioButton2;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JTextArea jTextArea1;
    private javax.swing.JTextArea jTextArea2;
    private javax.swing.JTextField jTextField1;
    private javax.swing.JTextField jTextField2;
    private javax.swing.JPanel lblEmbedPNL;
    private javax.swing.JPanel listEmbedPNL;
    private javax.swing.JPanel listEmbedPNL1;
    private javax.swing.JPanel plainComponentsPanel;
    private javax.swing.JLabel plainDesc;
    private javax.swing.JPanel rbEmbedPNL;
    private javax.swing.JPanel taEmbedPNL;
    private javax.swing.JPanel tfEmbedPNL;
    // End of variables declaration//GEN-END:variables
    
}
