/*
 * DropShadowBorderPanel.java
 *
 * Created on April 28, 2005, 10:27 AM
 */

package org.jdesktop.demo.swingx_dev;
import java.awt.Insets;
import java.io.File;
import javax.swing.JComponent;
import javax.swing.border.EtchedBorder;
import org.jdesktop.demo.DemoPanel;
import org.jdesktop.demo.MainWindow;
import org.jdesktop.swingx.border.DropShadowBorder;

/**
 *
 * @author  patrick
 */
public class DropShadowBorderPanel extends DemoPanel {
    EtchedBorder eb = new EtchedBorder();
    DropShadowBorder dsb = new DropShadowBorder();
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        MainWindow.main(new String[]{"-d", "org.jdesktop.demo.swingx.DropShadowBorderPanel"});
    }
   
    /** Creates new form DropShadowBorderPanel */
    public DropShadowBorderPanel() {
        setName("Drop Shadow Border Demo");
        initComponents();
        Insets i = jTextField1.getInsets();
        i.set(5,5,5,5);
    }

    public java.awt.Container getContents() {
        return this;
    }

    public String getHtmlDescription() {
        return "<html>Demonstrates various uses of drop-shadow borders.</html>";
    }

    public javax.swing.Icon getIcon() {
        return null;
    }
    
    public java.io.File getSourceRootDir() {
        try {
            System.out.println(getClass().getResource("/sources"));
            return new File(getClass().getResource("/sources").toURI());
        } catch (Exception e) {
            e.printStackTrace();
            return null;
        }
    }

    public java.awt.Container getContent() {
        return this;
    }
  
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        buttonGroup1 = new javax.swing.ButtonGroup();
        jPanel10 = new javax.swing.JPanel();
        jPanel1 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        jLabel5 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        jPanel2 = new javax.swing.JPanel();
        jLabel2 = new javax.swing.JLabel();
        jTextField2 = new javax.swing.JTextField();
        jButton2 = new javax.swing.JButton();
        jPanel3 = new javax.swing.JPanel();
        jLabel6 = new javax.swing.JLabel();
        jPanel4 = new javax.swing.JPanel();
        jLabel7 = new javax.swing.JLabel();
        jPanel7 = new javax.swing.JPanel();
        jTextField1 = new javax.swing.JTextField();
        jPanel8 = new javax.swing.JPanel();
        jButton1 = new javax.swing.JButton();
        jCheckBox1 = new javax.swing.JCheckBox();
        jRadioButton1 = new javax.swing.JRadioButton();
        jPanel5 = new javax.swing.JPanel();
        jComboBox1 = new javax.swing.JComboBox();
        jPanel6 = new javax.swing.JPanel();
        jScrollPane2 = new javax.swing.JScrollPane();
        jTextArea1 = new javax.swing.JTextArea();
        jPanel9 = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        jList1 = new javax.swing.JList();

        setLayout(new java.awt.GridBagLayout());

        jPanel10.setLayout(new java.awt.BorderLayout());

        jPanel10.setBorder(new DropShadowBorder(java.awt.Color.WHITE, 1, 3));
        jPanel10.setOpaque(false);
        jPanel1.setBackground(new java.awt.Color(255, 255, 255));
        jLabel1.setBackground(new java.awt.Color(255, 255, 255));
        jLabel1.setIcon(new javax.swing.ImageIcon(getClass().getResource("/org/jdesktop/demo/swingx/resources/duke_point.gif")));
        jLabel1.setOpaque(true);
        jLabel1.setPreferredSize(new java.awt.Dimension(75, 65));
        jLabel1.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseEntered(java.awt.event.MouseEvent evt) {
                jLabel1MouseEntered(evt);
            }
            public void mouseExited(java.awt.event.MouseEvent evt) {
                jLabel1MouseExited(evt);
            }
        });

        jPanel1.add(jLabel1);

        jLabel3.setBackground(new java.awt.Color(255, 255, 255));
        jLabel3.setIcon(new javax.swing.ImageIcon(getClass().getResource("/org/jdesktop/demo/swingx/resources/duke_hips.gif")));
        jLabel3.setHorizontalTextPosition(javax.swing.SwingConstants.LEADING);
        jLabel3.setIconTextGap(0);
        jLabel3.setMaximumSize(new java.awt.Dimension(55, 45));
        jLabel3.setMinimumSize(new java.awt.Dimension(55, 45));
        jLabel3.setOpaque(true);
        jLabel3.setPreferredSize(new java.awt.Dimension(75, 65));
        jLabel3.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseEntered(java.awt.event.MouseEvent evt) {
                jLabel3MouseEntered(evt);
            }
            public void mouseExited(java.awt.event.MouseEvent evt) {
                jLabel3MouseExited(evt);
            }
        });

        jPanel1.add(jLabel3);

        jLabel5.setBackground(new java.awt.Color(255, 255, 255));
        jLabel5.setIcon(new javax.swing.ImageIcon(getClass().getResource("/org/jdesktop/demo/swingx/resources/duke_thumbsup.gif")));
        jLabel5.setMaximumSize(new java.awt.Dimension(55, 32));
        jLabel5.setMinimumSize(new java.awt.Dimension(55, 45));
        jLabel5.setOpaque(true);
        jLabel5.setPreferredSize(new java.awt.Dimension(75, 65));
        jLabel5.setRequestFocusEnabled(false);
        jLabel5.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseEntered(java.awt.event.MouseEvent evt) {
                jLabel5MouseEntered(evt);
            }
            public void mouseExited(java.awt.event.MouseEvent evt) {
                jLabel5MouseExited(evt);
            }
        });

        jPanel1.add(jLabel5);

        jLabel4.setBackground(new java.awt.Color(255, 255, 255));
        jLabel4.setIcon(new javax.swing.ImageIcon(getClass().getResource("/org/jdesktop/demo/swingx/resources/duke_wave.gif")));
        jLabel4.setMaximumSize(new java.awt.Dimension(55, 45));
        jLabel4.setMinimumSize(new java.awt.Dimension(55, 32));
        jLabel4.setOpaque(true);
        jLabel4.setPreferredSize(new java.awt.Dimension(75, 65));
        jLabel4.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseEntered(java.awt.event.MouseEvent evt) {
                jLabel4MouseEntered(evt);
            }
            public void mouseExited(java.awt.event.MouseEvent evt) {
                jLabel4MouseExited(evt);
            }
        });

        jPanel1.add(jLabel4);

        jPanel10.add(jPanel1, java.awt.BorderLayout.CENTER);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 0.2;
        gridBagConstraints.insets = new java.awt.Insets(5, 12, 0, 11);
        add(jPanel10, gridBagConstraints);

        jPanel2.setBorder(new DropShadowBorder());
        jLabel2.setText("Name:");
        jPanel2.add(jLabel2);

        jTextField2.setColumns(25);
        jPanel2.add(jTextField2);

        jButton2.setText("OK");
        jButton2.setEnabled(false);
        jPanel2.add(jButton2);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(12, 12, 0, 11);
        add(jPanel2, gridBagConstraints);

        jPanel3.setBorder(new DropShadowBorder());
        jLabel6.setFont(new java.awt.Font("Courier New", 0, 11));
        jLabel6.setText("<html><h1>W<br>E<br>L<br>C<br>O<br>M<br>E<br></h1></html>");
        jPanel3.add(jLabel6);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridheight = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.VERTICAL;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(12, 12, 11, 0);
        add(jPanel3, gridBagConstraints);

        jLabel7.setText("First Name:");
        jLabel7.setBorder(new DropShadowBorder());
        jPanel4.add(jLabel7);

        jPanel7.setLayout(new java.awt.BorderLayout());

        jPanel7.setBorder(new DropShadowBorder());
        jTextField1.setText("jTextField1");
        jTextField1.setBorder(null);
        jPanel7.add(jTextField1, java.awt.BorderLayout.CENTER);

        jPanel4.add(jPanel7);

        jPanel8.setLayout(new java.awt.BorderLayout());

        jPanel8.setBorder(new DropShadowBorder());
        jButton1.setText("Submit");
        jButton1.setPreferredSize(new java.awt.Dimension(80, 25));
        jPanel8.add(jButton1, java.awt.BorderLayout.CENTER);

        jPanel4.add(jPanel8);

        jCheckBox1.setText("True");
        jCheckBox1.setBorder(new DropShadowBorder());
        jPanel4.add(jCheckBox1);

        jRadioButton1.setText("Marketing Materials");
        jRadioButton1.setBorder(new DropShadowBorder());
        jPanel4.add(jRadioButton1);

        jPanel5.setLayout(new java.awt.BorderLayout());

        jPanel5.setBorder(new DropShadowBorder(java.awt.Color.BLACK, 0, 3));
        jComboBox1.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Item1", "Item2", "Item3", "Item4" }));
        jPanel5.add(jComboBox1, java.awt.BorderLayout.CENTER);

        jPanel4.add(jPanel5);

        jPanel6.setLayout(new java.awt.BorderLayout(1, 1));

        jPanel6.setBorder(new DropShadowBorder());
        jPanel6.setOpaque(false);
        jScrollPane2.setBorder(null);
        jTextArea1.setColumns(30);
        jTextArea1.setLineWrap(true);
        jTextArea1.setRows(4);
        jTextArea1.setText("A test area text area. To get this effect, the JTextArea was placed within a JPanel, and the DropShadowBorder was placed on the JPanel. If you tried to add a DropShadowBorder to the JTextArea itself, you would get a funny effect because the Look and Feel installs a different border on the JTextArea in addition to the border specified.");
        jTextArea1.setWrapStyleWord(true);
        jTextArea1.setBorder(null);
        jScrollPane2.setViewportView(jTextArea1);

        jPanel6.add(jScrollPane2, java.awt.BorderLayout.NORTH);

        jPanel4.add(jPanel6);

        jPanel9.setLayout(new java.awt.BorderLayout());

        jPanel9.setBorder(new DropShadowBorder());
        jList1.setModel(new javax.swing.AbstractListModel() {
            String[] strings = { "Item1", "Item2", "Item3", "Item4" };
            public int getSize() { return strings.length; }
            public Object getElementAt(int i) { return strings[i]; }
        });
        jScrollPane1.setViewportView(jList1);

        jPanel9.add(jScrollPane1, java.awt.BorderLayout.CENTER);

        jPanel4.add(jPanel9);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 0.8;
        gridBagConstraints.insets = new java.awt.Insets(5, 12, 11, 11);
        add(jPanel4, gridBagConstraints);

    }
    // </editor-fold>//GEN-END:initComponents

    private void jLabel4MouseExited(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jLabel4MouseExited
        flipBorder((JComponent)evt.getSource(), false);
    }//GEN-LAST:event_jLabel4MouseExited

    private void jLabel5MouseExited(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jLabel5MouseExited
        flipBorder((JComponent)evt.getSource(), false);

    }//GEN-LAST:event_jLabel5MouseExited

    private void jLabel3MouseExited(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jLabel3MouseExited
        flipBorder((JComponent)evt.getSource(), false);

    }//GEN-LAST:event_jLabel3MouseExited

    private void jLabel4MouseEntered(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jLabel4MouseEntered
        flipBorder((JComponent)evt.getSource(), true);

    }//GEN-LAST:event_jLabel4MouseEntered

    private void jLabel5MouseEntered(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jLabel5MouseEntered
        flipBorder((JComponent)evt.getSource(), true);
    }//GEN-LAST:event_jLabel5MouseEntered

    private void jLabel3MouseEntered(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jLabel3MouseEntered
        flipBorder((JComponent)evt.getSource(), true);
    }//GEN-LAST:event_jLabel3MouseEntered

    private void jLabel1MouseExited(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jLabel1MouseExited
        flipBorder((JComponent)evt.getSource(), false);
    }//GEN-LAST:event_jLabel1MouseExited

    private void jLabel1MouseEntered(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jLabel1MouseEntered
        flipBorder((JComponent)evt.getSource(), true);
    }//GEN-LAST:event_jLabel1MouseEntered
    
    private void flipBorder(JComponent comp, boolean shadow) {
            comp.setBorder(shadow ? dsb : null);
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.ButtonGroup buttonGroup1;
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JCheckBox jCheckBox1;
    private javax.swing.JComboBox jComboBox1;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JList jList1;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel10;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JPanel jPanel6;
    private javax.swing.JPanel jPanel7;
    private javax.swing.JPanel jPanel8;
    private javax.swing.JPanel jPanel9;
    private javax.swing.JRadioButton jRadioButton1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JTextArea jTextArea1;
    private javax.swing.JTextField jTextField1;
    private javax.swing.JTextField jTextField2;
    // End of variables declaration//GEN-END:variables
    
}
